// Desktop Scroller.
// Copyright (C) 2011 Marcos Diaz <diazmencia@gmail.com>.
//
// Desktop Scroller is libre software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation, either version 3 of the License, or newer.
//
// You should have received a copy of the GNU General Public License along with
// this file. If not, see <http://www.gnu.org/licenses/>.

const St = imports.gi.St
const Main = imports.ui.main

// Main class for the extension.
function main(){
	this._init = function(){
		var monitor = Main.layoutManager.primaryMonitor
		var x = monitor.width - 1
		var y = 30
		var width = 1
		var height = monitor.height
		this.actor = new St.Button({style_class:'desktopscroller'})
		this.actor.set_position(x,y)
		this.actor.set_width(width)
		this.actor.set_height(height)
		this.actor.opacity = 0
		this.actor.connect('scroll-event', bind(this, this.hook))
		Main.layoutManager.addChrome(this.actor)
	}
	this.hook = function(actor, event){
		var direction = event.get_scroll_direction()
		if(direction==0) this.switch_workspace(-1)
		if(direction==1) this.switch_workspace(1)
	}
	this.switch_workspace = function(incremental){
		var index = global.screen.get_active_workspace_index()
		index += incremental
		global.screen.get_workspace_by_index(index).activate(true)
	}
	this._init()
}

// Gnome-shell extension API.
function init(){
	desktopscroller = new main()
}
function enable(){
	if(!desktopscroller) init()
}
function disable(){
	desktopscroller.actor.destroy()	         // Javascript garbage collector
	desktopscroller = undefined              // should delete the whole object.
}

// Other utils.
function bind(scope, func){
	return function(){
		func.apply(scope, arguments)
	}
}


